## GitLab CI configurations

# Pipeline stages
stages:
  - build
  - publish

## Import common gitlab-ci defs
include:
- project: ${CI_PROJECT_ROOT_NAMESPACE}/ops/ci
  file: /gitlab/common.yml

## Create a GitLba pipeline if the following rules apply
workflow:
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_COMMIT_TAG != null
    - if: $CI_MERGE_REQUEST_ID # If in a Merge Request context

# Default settings for all jobs
default:
  interruptible: true
  tags:
    - cluster
    - kubernetes



#=============================================================================
## Pipeline Jobs


# Merge Request

build+test:all:
  extends:
    - .rules:mr-only-auto
    - .build+test:all
  stage: build
  script:
    - ./tools/ci/scan-secrets.sh
    - ./tools/ci/build.sh
    - ./tools/ci/test.sh
    - ./tools/ci/generate-artifacts.sh


# Master

publish:all:
  extends:
    - .rules:master-only-auto
    - .publish:all
  stage: publish
  script:
    - ./tools/ci/scan-secrets.sh
    - ./tools/ci/push-images.sh
    - ./tools/ci/generate-artifacts.sh
